import pyaudio
import wave
import struct

import numpy as np
import scipy as sc
from scipy import signal
import cv2

import serial # to talk to arduino
serialLink = serial.Serial('/dev/tty.usbmodem14101', 9600)

# much of this is adaptend from the docs: 
# https://people.csail.mit.edu/hubert/pyaudio/
audio = pyaudio.PyAudio()
audiostream = audio.open(
    format=pyaudio.paInt16,
    channels=1,
    rate=44100,
    input=True,
    output=True,
    frames_per_buffer=1024
)

# capturing mean and max for thresholding
max = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
sumean = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]

for i in range(0, int(44100 / 1024 * 300)):
    data = audiostream.read(1024)

    # converstion thanks to: https://github.com/markjay4k/Audio-Spectrum-Analyzer-in-Python/blob/master/audio_spectrum.py
    data_int = struct.unpack(str(2 * 1024) + 'B', data)
    data_np = np.array(data_int, dtype='b')[::2] + 128

    # learned this in Machine Learning + Sensing class
    f,t,pxx = signal.spectrogram(data_np, nperseg=512, fs=44100, noverlap=512/2)
    resized_pxx=cv2.resize(pxx[:,:],(1,16))

    # mean and max for hand calibrating in demo... should use ML to set in the future
    for bucket in range(len(max)):
        if(resized_pxx[bucket][0] > max[bucket]):
            max[bucket] = resized_pxx[bucket][0]
        sumean[bucket] = sumean[bucket]+ resized_pxx[bucket][0]

    # just eyeballed some thresholds in the middle range
    if(resized_pxx[9][0]>0.7 or resized_pxx[8][0]>0.5):
        print("thump")
        serialLink.write(b'1')
        

print(max)

# turn sum into mean
for x in range (len(sumean)):
    sumean[x] = sumean[x]/i

print(sumean)

audiostream.stop_stream()
audiostream.close()
audio.terminate()
